/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/config/env-config.ts":
/*!**********************************!*\
  !*** ./src/config/env-config.ts ***!
  \**********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.config = void 0;
const envalid_1 = __webpack_require__(/*! envalid */ "envalid");
exports.config = (0, envalid_1.cleanEnv)(process.env, {
    S_AUTHORIZATION_HEADER: (0, envalid_1.str)(),
    S_GRAPHQL_URL: (0, envalid_1.str)(),
    S_START_SEQ: (0, envalid_1.num)(),
    S_END_SEQ: (0, envalid_1.num)(),
    MONGO_URL: (0, envalid_1.str)({ devDefault: 'mongodb://localhost:27017/S_MARKET' }),
});


/***/ }),

/***/ "./src/config/index.ts":
/*!*****************************!*\
  !*** ./src/config/index.ts ***!
  \*****************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
__exportStar(__webpack_require__(/*! ./env-config */ "./src/config/env-config.ts"), exports);


/***/ }),

/***/ "./src/store/curd-insert.ts":
/*!**********************************!*\
  !*** ./src/store/curd-insert.ts ***!
  \**********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.mongoClient = void 0;
const mongodb_1 = __webpack_require__(/*! mongodb */ "mongodb");
const config_1 = __webpack_require__(/*! ../config */ "./src/config/index.ts");
const mongoClient = new mongodb_1.MongoClient(config_1.config.MONGO_URL);
exports.mongoClient = mongoClient;


/***/ }),

/***/ "./src/store/marketing.ts":
/*!********************************!*\
  !*** ./src/store/marketing.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.MarketingContactModelFunc = void 0;
const mongoose_1 = __webpack_require__(/*! mongoose */ "mongoose");
const store_mongo_1 = __webpack_require__(/*! @common-stack/store-mongo */ "@common-stack/store-mongo");
const marketingContactModelSchema = new mongoose_1.Schema({
    originalId: { type: mongoose_1.Schema.Types.String },
    uuid: { type: mongoose_1.Schema.Types.String },
    orgName: { type: mongoose_1.Schema.Types.String, default: 'leslie89899' },
    name: { type: mongoose_1.Schema.Types.String },
    firstName: { type: mongoose_1.Schema.Types.String },
    lastName: { type: mongoose_1.Schema.Types.String },
    fullName: { type: mongoose_1.Schema.Types.String },
    address: { type: mongoose_1.Schema.Types.String },
    addressDescription: { type: mongoose_1.Schema.Types.String },
    address2: { type: mongoose_1.Schema.Types.String },
    city: { type: mongoose_1.Schema.Types.String },
    state: { type: mongoose_1.Schema.Types.String },
    country: { type: mongoose_1.Schema.Types.String },
    zip: { type: mongoose_1.Schema.Types.String },
    phone: { type: mongoose_1.Schema.Types.String },
    phoneExt: { type: mongoose_1.Schema.Types.String },
    phone2: { type: mongoose_1.Schema.Types.String },
    email: { type: mongoose_1.Schema.Types.String },
    company: { type: mongoose_1.Schema.Types.String },
    ip: { type: mongoose_1.Schema.Types.String },
    datestamp: { type: mongoose_1.Schema.Types.Date },
    use: { type: mongoose_1.Schema.Types.String },
    code: { type: mongoose_1.Schema.Types.String },
    optIn: { type: mongoose_1.Schema.Types.Boolean },
    createDate: { type: mongoose_1.Schema.Types.Date },
    isGuest: { type: mongoose_1.Schema.Types.Boolean },
    mailerType: { type: mongoose_1.Schema.Types.String },
    optOutReason: { type: mongoose_1.Schema.Types.String },
    lastVrUpdate: { type: mongoose_1.Schema.Types.Date },
    bounceCounter: { type: mongoose_1.Schema.Types.Number },
    site: { type: mongoose_1.Schema.Types.String },
    lastLogin: { type: mongoose_1.Schema.Types.Date },
    isAppUser: { type: mongoose_1.Schema.Types.Boolean },
    interactionSent: { type: mongoose_1.Schema.Types.Boolean },
    isVerified: { type: mongoose_1.Schema.Types.Boolean },
    unit: { type: mongoose_1.Schema.Types.String },
    unitType: { type: mongoose_1.Schema.Types.String },
    isActive: { type: mongoose_1.Schema.Types.Boolean },
}, Object.assign(Object.assign({}, store_mongo_1.commonModeSchemaOptions), { collection: 'marketingContacts' }));
marketingContactModelSchema.pre('save', function (next) {
    var _a;
    if (!this.get('fullName')) {
        const [firstName, lastName] = ((_a = this.get('fullName')) === null || _a === void 0 ? void 0 : _a.split(' ')) || [];
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-ignore
        this.firstName = firstName;
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-ignore
        this.lastName = lastName;
    }
    else {
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-ignore
        this.fullName = `${this.get('firstName')} ${this.get('lastName')}`;
    }
    next();
});
(0, store_mongo_1.addIdVirtualFields)(marketingContactModelSchema);
const MarketingContactModelFunc = (db) => db.model('MarketingContact', marketingContactModelSchema);
exports.MarketingContactModelFunc = MarketingContactModelFunc;


/***/ }),

/***/ "./src/transformToMarketContacts.ts":
/*!******************************************!*\
  !*** ./src/transformToMarketContacts.ts ***!
  \******************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const dotenv = __importStar(__webpack_require__(/*! dotenv */ "dotenv"));
__webpack_require__(/*! reflect-metadata */ "reflect-metadata");
const uuid_1 = __webpack_require__(/*! uuid */ "uuid");
if (process.env.ENV_FILE) {
    dotenv.config({ path: process.env.ENV_FILE });
}
const marketing_1 = __webpack_require__(/*! ./store/marketing */ "./src/store/marketing.ts");
const config_1 = __webpack_require__(/*! ./config */ "./src/config/index.ts");
const curd_insert_1 = __webpack_require__(/*! ./store/curd-insert */ "./src/store/curd-insert.ts");
const mongoose_1 = __webpack_require__(/*! mongoose */ "mongoose");
const initial = config_1.config.S_START_SEQ;
const final = config_1.config.S_END_SEQ;
const batchSize = 10000; // Set your preferred batch size
// Function to transform and import a single document
async function transformAndImportDocument(existingDocument, marketingContacts, batch) {
    try {
        // Generate a new UUID
        const newUuid = (0, uuid_1.v4)();
        // Transform the existing document into the new schema structure
        const transformedDocument = {
            originalId: existingDocument._id,
            uuid: newUuid,
            orgName: 'leslieMar',
            name: existingDocument.fullName,
            firstName: existingDocument.firstName,
            lastName: existingDocument.lastName,
            address: existingDocument.address,
            address2: existingDocument.address2,
            city: existingDocument.city,
            state: existingDocument.state,
            zip: existingDocument.zip,
            phone: existingDocument.phone,
            email: existingDocument.email,
            company: '',
            // ip: existingDocument.owner_verifications[0].pool_proof_url || '', // Check the appropriate field
            datestamp: existingDocument.createdAt,
            use: '',
            code: '',
            optIn: false,
            createDate: '',
            isGuest: false,
            mailerType: '',
            optOutReason: '',
            lastVrUpdate: '',
            bounceCounter: 0,
            site: '',
            lastLogin: existingDocument.lastLogin,
            isAppUser: false,
            interactionSent: false,
            isVerified: existingDocument.is_verified,
            unit: '',
            unitType: '',
            isActive: false, // Adjust based on your criteria
        };
        // Push the transformed document to the batch
        batch.push(transformedDocument);
        // If the batch size is reached, insert the batch into the database
        if (batch.length >= batchSize) {
            await marketingContacts.insertMany(batch);
            console.log(`Batch of ${batch.length} documents saved.`);
            // Clear the batch
            batch.length = 0;
        }
    }
    catch (error) {
        console.error('Error saving document', error);
    }
}
const startJob = async () => {
    console.time('dbsave');
    try {
        await curd_insert_1.mongoClient.connect();
        const db = curd_insert_1.mongoClient.db('S_DATA');
        const cursor = db.collection('pool').find(); // Retrieve all documents
        let batch = [];
        const conn = await (0, mongoose_1.createConnection)(config_1.config.MONGO_URL, {}).asPromise();
        const marketingContacts = (0, marketing_1.MarketingContactModelFunc)(conn);
        while (await cursor.hasNext()) {
            const existingDocument = await cursor.next();
            await transformAndImportDocument(existingDocument, marketingContacts, batch);
        }
        // Insert any remaining documents in the batch
        if (batch.length > 0) {
            await marketingContacts.insertMany(batch);
            console.log(`Final batch of ${batch.length} documents saved.`);
        }
        console.log('All documents imported successfully.');
    }
    catch (error) {
        console.error('Error importing documents:', error);
    }
    finally {
        console.log('imported with missing ones as follow');
        await curd_insert_1.mongoClient.close();
        console.timeEnd('dbsave');
    }
};
startJob().catch(console.dir);


/***/ }),

/***/ "@common-stack/store-mongo":
/*!********************************************!*\
  !*** external "@common-stack/store-mongo" ***!
  \********************************************/
/***/ ((module) => {

module.exports = require("@common-stack/store-mongo");

/***/ }),

/***/ "dotenv":
/*!*************************!*\
  !*** external "dotenv" ***!
  \*************************/
/***/ ((module) => {

module.exports = require("dotenv");

/***/ }),

/***/ "envalid":
/*!**************************!*\
  !*** external "envalid" ***!
  \**************************/
/***/ ((module) => {

module.exports = require("envalid");

/***/ }),

/***/ "mongodb":
/*!**************************!*\
  !*** external "mongodb" ***!
  \**************************/
/***/ ((module) => {

module.exports = require("mongodb");

/***/ }),

/***/ "mongoose":
/*!***************************!*\
  !*** external "mongoose" ***!
  \***************************/
/***/ ((module) => {

module.exports = require("mongoose");

/***/ }),

/***/ "reflect-metadata":
/*!***********************************!*\
  !*** external "reflect-metadata" ***!
  \***********************************/
/***/ ((module) => {

module.exports = require("reflect-metadata");

/***/ }),

/***/ "uuid":
/*!***********************!*\
  !*** external "uuid" ***!
  \***********************/
/***/ ((module) => {

module.exports = require("uuid");

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__("./src/transformToMarketContacts.ts");
/******/ 	module.exports = __webpack_exports__;
/******/ 	
/******/ })()
;
//# sourceMappingURL=transformToMC.js.map